#!/bin/bash
set -eu

CONVERTED_FILE=processed.pnm
FW_INFILE="$1"
TARGET="$2"
./anytoppm.sh "$FW_INFILE" $CONVERTED_FILE || exit 1

#generate logo for the phone
PREVIEW=_preview.png
FW_IDENT=logo_sip

case $FW_IDENT in
	logo_sip)
		# BMP 90x56 (8-bit), phone can display 4 colors
		{ cat $CONVERTED_FILE | pnmscale -width 90 -height 56 | ppmquant 4 | ./ppmfix.sh | ppmtobmp -bpp=8 > $TARGET; } 2>/dev/null

		#generate logo preview for Operator's Administration
		{ cat $TARGET | bmptopnm | ./ppmfix.sh | pnmtopng > $PREVIEW; } 2>/dev/null
	;;
	logo_sep_bw)
		# PNG 320x196 (8-bit), phone can display a 4 color PNG file
		{ cat $CONVERTED_FILE | pnmscale -width 320 -height 196 | ppmquant 4 | ./ppmfix.sh | pnmtopng > $TARGET; } 2>/dev/null
		# BMP 80x49 (8-bit), phone can display a 4 color PNG file
		{ cat $CONVERTED_FILE | pnmscale -width 80 -height 49 | ppmquant 4 | ./ppmfix.sh | pnmtopng > $TARGET_TN; } 2>/dev/null

		#generate logo preview for Operator's Administration
		cp $TARGET $PREVIEW
	;;
	logo_sep_color)
		# PNG 320x212 (12-bit)
		{ cat $CONVERTED_FILE | pnmscale -width 320 -height 212 | ppmquant 4096 | ./ppmfix.sh | pnmtopng > $TARGET; } 2>/dev/null
		# PNG 80x53 (12-bit)
		{ cat $CONVERTED_FILE | pnmscale -width 80 -height 53 | ppmquant 4096 | ./ppmfix.sh | pnmtopng > $TARGET_TN; } 2>/dev/null

		#generate logo preview for Operator's Administration
		cp $TARGET $PREVIEW
	;;
		logo_sep_color_16)
		# PNG 320x212 (16-bit)
		{ cat $CONVERTED_FILE | pnmscale -width 320 -height 212 | ppmquant 65536 | ./ppmfix.sh | pnmtopng > $TARGET; } 2>/dev/null
		# PNG 80x53 (16-bit)
		{ cat $CONVERTED_FILE | pnmscale -width 80 -height 53 | ppmquant 65536 | ./ppmfix.sh | pnmtopng > $TARGET_TN; } 2>/dev/null

		#generate logo preview for Operator's Administration
		cp $TARGET $PREVIEW
	;;
	*)
		echo "Unknown logo ident. [$FW_IDENT]" >&2
		exit 1
	;;
esac



